=== python/examples/CMakeLists.txt ===
 install(FILES simple.py complete.py cbus.py
         DESTINATION share/libftdi/examples
         PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
 )
