=== debian/changelog ===
libftdi1 (1.6~rc1-1) unstable; urgency=medium

  * New upstream release candidate
  * Remove all patches, all merged upstream
  * Update symbols file
  * Update libftdipp1 symbols file to catch an architecture specific
    internal c++ symbol
  * Update debian/copyright
  * Update debian/watch to version 5
  * Stop forcing CMAKE_POLICY_VERSION_MINIMUM, new upstream version is
    compatible with CMake 4
  * debian/control: drop Rules-Requires-Root field, now obsolete
  * debian/control: drop Priority field, optional is now the default
  * Bump Standards-Version to 4.7.3 (no changes)

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 03 Jan 2026 13:52:23 +0100

libftdi1 (1.5-12) unstable; urgency=medium

  * Configure with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113153)

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 01 Sep 2025 19:11:29 +0200

libftdi1 (1.5-11) unstable; urgency=medium

  * Make libboost-test-dev build-dependency optional via <!nocheck>. Thanks
    to Helmut Grohne <helmut@subdivi.de>
  * Backport 05-boost-dependency.diff from upstream, drop
    (build-)dependencies on libboost-dev, and adjust libftdipp1-3 symbols
    file.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 12 Aug 2025 11:33:34 +0200
