=== debian/watch ===
Version: 5

Source: https://www.intra2net.com/en/developer/libftdi/download.php
Matching-Pattern: download/libftdi1-(.+)\.tar\.bz2
